=== debian/changelog ===
gammaray (2.11.3-3) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * qtwebengine5-dev is now available on mips64el.

  [ Dmitry Shachnev ]
  * Update debian/watch to use GitHub API and add signature verification.
    - Remove no longer needed debian/source/lintian-overrides.
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Dmitry Shachnev <mitya57@debian.org>  Thu, 02 Mar 2023 21:03:05 +0300

gammaray (2.11.3-2) unstable; urgency=medium

  * Team upload.
  * Make test failures non-fatal on ppc64el (closes: #1026932).

 -- Dmitry Shachnev <mitya57@debian.org>  Sat, 24 Dec 2022 19:06:21 +0300

gammaray (2.11.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Refresh patches.
  * Update KDAB's copyright.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 21 Apr 2022 18:53:33 -0300
