## gammaray 3.1.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,42 +1,47 @@
 Source: gammaray
 Priority: optional
 Section: devel
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Jakub Adam <jakub.adam@ktknet.cz>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                gdb,
                glslang-tools,
                libgraphviz-dev,
-               libkf5coreaddons-dev,
-               libkf5syntaxhighlighting-dev,
+               libkf6coreaddons-dev,
+               libkf6syntaxhighlighting-dev,
                libproj-dev,
-               libqt5svg5-dev,
-               libqt5waylandcompositor5-dev,
                libwayland-dev (>= 1.12.0),
-               qml-module-qtqml,
-               qml-module-qtquick2,
-               qt3d-assimpsceneimport-plugin,
-               qt3d-defaultgeometryloader-plugin,
-               qt3d-gltfsceneio-plugin,
-               qt3d-scene2d-plugin,
-               qt3d5-dev (>= 5.14),
-               qtbase5-private-dev,
-               qtconnectivity5-dev,
-               qtdeclarative5-dev,
-               qtdeclarative5-dev-tools,
-               qtdeclarative5-private-dev,
-               qtlocation5-dev,
-               qtpositioning5-dev,
-               qtscript5-dev,
-               qttools5-dev,
-               qttools5-dev-tools,
-               qttranslations5-l10n,
-               qtwayland5,
-               qtwebengine5-dev [amd64 arm64 armhf i386 mips64el mipsel],
+               qml6-module-qtqml,
+               qml6-module-qtqml-workerscript,
+               qml6-module-qtquick,
+               qml6-module-qtquick-controls,
+               qml6-module-qtquick-templates,
+               qml6-module-qtquick-window,
+               qt6-3d-assimpsceneimport-plugin,
+               qt6-3d-defaultgeometryloader-plugin,
+               qt6-3d-dev,
+               qt6-3d-gltfsceneio-plugin,
+               qt6-3d-scene2d-plugin,
+               qt6-base-private-dev,
+               qt6-connectivity-dev,
+               qt6-declarative-dev,
+               qt6-declarative-dev-tools,
+               qt6-declarative-private-dev,
+               qt6-location-dev,
+               qt6-positioning-dev,
+               qt6-shadertools-dev,
+               qt6-svg-dev,
+               qt6-tools-dev,
+               qt6-tools-dev-tools,
+               qt6-translations-l10n,
+               qt6-wayland,
+               qt6-wayland-dev,
+               qt6-webengine-dev [amd64 arm64 armhf i386],
                xauth,
                xvfb
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/gammaray.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/gammaray
 Homepage: https://www.kdab.com/development-resources/qt-tools/gammaray/
@@ -44,9 +49,8 @@
 Package: gammaray
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: qml-module-qt3d,
-         qml-module-qtquick-controls,
-         qml-module-qtquick-scene3d,
+Depends: qml6-module-qtquick-controls,
+         qml6-module-qtquick-scene3d,
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: gdb
@@ -61,8 +65,8 @@
 Package: gammaray-plugin-quickinspector
 Architecture: any
 Depends: gammaray (= ${binary:Version}),
-         qml-module-qtquick-controls,
-         qml-module-qtquick2,
+         qml6-module-qtquick,
+         qml6-module-qtquick-controls,
          ${misc:Depends},
          ${shlibs:Depends}
 Enhances: gammaray
@@ -105,14 +109,14 @@
 Package: gammaray-plugin-positioning
 Architecture: any
 Depends: gammaray (= ${binary:Version}),
-         qml-module-qtlocation,
-         qml-module-qtpositioning,
-         qml-module-qtquick2,
+         qml6-module-qtlocation,
+         qml6-module-qtpositioning,
+         qml6-module-qtquick,
          ${misc:Depends},
          ${shlibs:Depends}
 Enhances: gammaray
-Description: Qt5Positioning type support for GammaRay
- This plugin adds support for Qt5Positioning types into GammaRay.
+Description: Qt6Positioning type support for GammaRay
+ This plugin adds support for Qt6Positioning types into GammaRay.
 
 Package: gammaray-dev
 Architecture: any
